import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class InterfazEmpleado{
	public static Empresa e;
	public static void main(String args[]){
		//Crea una nueva empresa de 10 empleados
		e = new Empresa(10);
		
		FrameEmpleado frm = new FrameEmpleado();
		frm.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frm.show();
    }
}

class FrameEmpleado extends JFrame{
	JLabel lblID = new JLabel("ID. empleado: ",JLabel.RIGHT);
	JLabel lblNombre = new JLabel("Nombre: ",JLabel.RIGHT);
	JLabel lblSueldo = new JLabel("Sueldo: ",JLabel.RIGHT);
	JLabel lblComplemento = new JLabel("Complemento: ",JLabel.RIGHT);
	JLabel lblHoras = new JLabel("Horas:   ");
	JTextField txtID = new JTextField(40);
	JTextField txtNombre = new JTextField(40);
	JTextField txtSueldo = new JTextField(40);
	JTextField txtComplemento = new JTextField(40);
	JTextField txtHoras = new JTextField(40);
	JButton btnFijo = new JButton("Empleado fijo");
	JButton btnEventual = new JButton("Empleado eventual");
	
	FrameEmpleado(){
		setTitle("Empleados");
		setResizable(false);
		Box caja = Box.createVerticalBox();
		caja.add(Box.createVerticalStrut(5));
		
		//b1 crea un contenedor para el Id de empleado
		Box b1 = Box.createHorizontalBox();
		b1.add(Box.createHorizontalStrut(5));
		b1.add(lblID);
		txtID.setMaximumSize(txtID.getPreferredSize());		
		b1.add(txtID);
		b1.add(Box.createHorizontalStrut(5));
		caja.add(b1);
		caja.add(Box.createVerticalStrut(5));
		
		//b2 crea un contenedor para el nombre de empleado
		Box b2 = Box.createHorizontalBox();
		b2.add(Box.createHorizontalStrut(5));
		b2.add(lblNombre);
		txtNombre.setMaximumSize(txtNombre.getPreferredSize());
		b2.add(txtNombre);
		b2.add(Box.createHorizontalStrut(5));
		caja.add(b2);
		caja.add(Box.createVerticalStrut(5));
		
		//b3 crea un contenedor para el sueldo del empleado
		Box b3 = Box.createHorizontalBox();
		b3.add(Box.createHorizontalStrut(5));
		b3.add(lblSueldo);
		txtSueldo.setMaximumSize(txtSueldo.getPreferredSize());			
		b3.add(txtSueldo);
		b3.add(Box.createHorizontalStrut(5));
		caja.add(b3);
		caja.add(Box.createVerticalStrut(5));
		
		//b4 crea un contenedor para el complemento de los empleados fijos
		Box b4 = Box.createHorizontalBox();
		b4.add(Box.createHorizontalStrut(5));
		b4.add(lblComplemento);		
		b4.add(txtComplemento);
		txtComplemento.setMaximumSize(txtComplemento.getPreferredSize());
		b4.add(Box.createHorizontalStrut(5));
		caja.add(b4);
		caja.add(Box.createRigidArea(new Dimension(20,5)));
		
		//b5 crea un contenedor para la horas de los empleados eventuales
		Box b5 = Box.createHorizontalBox();		
		b5.add(Box.createHorizontalStrut(5));			
		b5.add(lblHoras);
		b5.add(txtHoras);
		txtHoras.setMaximumSize(txtHoras.getPreferredSize());
		b5.add(Box.createHorizontalStrut(5));			
		caja.add(b5);
		caja.add(Box.createRigidArea(new Dimension(20,5)));

		//b6 crea un contenedor para los botones
		Box b6 = Box.createHorizontalBox();
		caja.add(Box.createGlue());
		b6.add(btnFijo);
		b6.add(Box.createHorizontalStrut(5));
		b6.add(btnEventual);
		caja.add(b6);
		
		getContentPane().add(caja);	
		setSize(270,210); 
		
		//Registra los interfaces en los componentes
		btnFijo.addActionListener(new EmpleadoActionListener());
		btnEventual.addActionListener(new EmpleadoActionListener());
		
	}
	
	//Gestin de eventos
	class EmpleadoActionListener implements ActionListener{
		public void actionPerformed(ActionEvent e){
			//Obtiene el objeto que ha producido el evento	
			Object source = e.getSource();
			Empleado emp = null;
			//Todos los empleados tienen id y nombre
			long id = Long.parseLong(txtID.getText());
			String nom = new String(txtNombre.getText());
			
			if(source == btnFijo){
				//Si el empleado es fijo, se crea un Empleado de la
				//subclase EmpleadoFijo (con sueldo y complemento)
				double complemento = Double.parseDouble(txtComplemento.getText());
				double sueldo = Double.parseDouble(txtSueldo.getText());
				emp = new EmpleadoFijo(id,nom,complemento);
				emp.setSueldo(sueldo);
			}
			else 
				if(source == btnEventual){
					//Si el empleado es eventual, se crea un Empleado de la
					//subclase EmpleadoEmpleadoEventual (con horas)
					int horas = Integer.parseInt(txtHoras.getText());
					emp = new EmpleadoEventual(id,nom,horas);
					emp.calcularSueldo();
				}
			
			//Muestra mensajes por la consola para comprobar si
			//se han creado los empleados
			System.out.println(emp);
			Empresa.nomina[Empleado.cuantosEmpleados()] = emp;
			Empresa.listarEmpleados();
			
			//Limpiar campos
			txtID.setText("");
			txtNombre.setText("");
			txtSueldo.setText("");
			txtHoras.setText("");
			txtComplemento.setText("");					
		}
	}	

}
